//
// CheckArc.c
// CheckArchive
//

//ZipTV Routine of Bh32.dll:
/**********************************************************************

  Copyright 1998-2004,  Microchip Data Systems / Carl Bunton

  Any revision or distribution of sources or any compiled dll dealing
  with the BlakHole (.bh extension) compression format requires this
  copyright notice be included in the source, documentation, and help
  files.

  Alterations to the BlakHole compressed header format can not be
  made without prior express written consent by the author.

  Web-site:  http://www.ziptv.com
**********************************************************************/

#include "StdAfx.h"

/*
ErrorCode:
0 -> TRUE
1 -> FALSE
2 -> DLLȂ
3 -> ֐T|[g
4 -> o͂Ȃ
*/
int CheckArchive_ChkArc(LPCSTR szDll, LPCSTR szPrefix, LPCSTR szArchive, const int iMode){
	int result=2;
	char szCheck[20];
	HMODULE hDll = LoadLibrary(szDll);

	wsprintf(szCheck,"%s%s",szPrefix,CHECK);

	if (hDll){
		FARPROC fp = GetProcAddress(hDll,szCheck);
		if (fp)
			result = ((CheckArchive)fp)(szArchive,0) ? 0 : 1;
		else
			result++;
	}
	FreeLibrary(hDll);

	return iMode==1 ? (result==0 ? 0 : 4) : iMode==2 ? (result==0 ? 0 : result==1 ? 1 : 4) : result;
}

void CheckArchive_Print(LPCSTR szString, const int iResult){
	char szDllstr[20];
	wsprintf(szDllstr,"%-12s -> ",szString);
	switch(iResult){
		case 0:
			ConsoleAqua();
			printf("%sTRUE\n",szDllstr);
			return;
		case 1:
			ConsoleYellow();
			printf("%sFALSE\n",szDllstr);
			return;
		case 2:
			ConsolePurple();
			printf("%sNot Found\n",szDllstr);
			return;
		case 3:
			ConsoleRed();
			printf("%sNot Supported\n",szDllstr);
			return;
	}
}

int CheckArchive_Check(LPCSTR szArchive, const int iMode){
	int r;
	if (!szArchive){
		ConsoleRed();
		printf(ConsoleIsJP()?"ɂw肳Ă܂":"Archive NOT Specified.");
		return 101;
	}

	ConsoleAqua();
	printf("%s() -> %s\n(%s)\n\n",CHECK,szArchive,
			ConsoleIsJP()?"gpł\DLL̂":"Available Library Only.");

	//LHA
	r=CheckArchive_ChkArc(UNLHA32DLL,UNLHA32PRE,szArchive,iMode);
	   CheckArchive_Print(UNLHA32DLL,r);
	r=CheckArchive_ChkArc(IUNLHA32DLL,IUNLHA32PRE,szArchive,iMode);
	   CheckArchive_Print(IUNLHA32DLL,r);
	//ZIP
	r=CheckArchive_ChkArc(UNZIP32DLL,UNZIP32PRE,szArchive,iMode);
	   CheckArchive_Print(UNZIP32DLL,r);
	r=CheckArchive_ChkArc(ZIP32JDLL,ZIP32JPRE,szArchive,iMode);
	   CheckArchive_Print(ZIP32JDLL,r);
	r=CheckArchive_ChkArc(LMZIP32DLL,LMZIP32PRE,szArchive,iMode);
	   CheckArchive_Print(LMZIP32DLL,r);
	//CAB
	r=CheckArchive_ChkArc(CAB32DLL,CAB32PRE,szArchive,iMode);
	   CheckArchive_Print(CAB32DLL,r);
	//ARJ
	r=CheckArchive_ChkArc(UNARJ32JDLL,UNARJ32JPRE,szArchive,iMode);
	   CheckArchive_Print(UNARJ32JDLL,r);
	//TAR
	r=CheckArchive_ChkArc(TAR32DLL,TAR32PRE,szArchive,iMode);
	   CheckArchive_Print(TAR32DLL,r);
	//BGA
	r=CheckArchive_ChkArc(BGA32DLL,BGA32PRE,szArchive,iMode);
	   CheckArchive_Print(BGA32DLL,r);
	//BEL
	r=CheckArchive_ChkArc(UNBEL32DLL,UNBEL32PRE,szArchive,iMode);
	   CheckArchive_Print(UNBEL32DLL,r);
	//GCA
	r=CheckArchive_ChkArc(UNGCA32DLL,UNGCA32PRE,szArchive,iMode);
	   CheckArchive_Print(UNGCA32DLL,r);
	//YZ1
	r=CheckArchive_ChkArc(YZ1DLL,YZ1PRE,szArchive,iMode);
	   CheckArchive_Print(YZ1DLL,r);
	r=CheckArchive_ChkArc(UNYZ1DLL,UNYZ1PRE,szArchive,iMode);
	   CheckArchive_Print(UNYZ1DLL,r);
	r=CheckArchive_ChkArc(YYZ32DLL,YZ1PRE,szArchive,iMode);
	   CheckArchive_Print(YYZ32DLL,r);
	r=CheckArchive_ChkArc(YYZDLL,YYZPRE,szArchive,iMode);
	   CheckArchive_Print(YYZDLL,r);
	//YZ2
	r=CheckArchive_ChkArc(YZ2DLL,YZ2PRE,szArchive,iMode);
	   CheckArchive_Print(YZ2DLL,r);
	//RAR
	r=CheckArchive_ChkArc(UNRAR32DLL,UNRAR32PRE,szArchive,iMode);
	   CheckArchive_Print(UNRAR32DLL,r);
	//ACE
	r=CheckArchive_ChkArc(UNACE32DLL,UNACE32PRE,szArchive,iMode);
	   CheckArchive_Print(UNACE32DLL,r);
	r=CheckArchive_ChkArc(UNACEV2JDLL,UNACEV2JPRE,szArchive,iMode);
	   CheckArchive_Print(UNACEV2JDLL,r);
	r=CheckArchive_ChkArc(ACE32DLL,ACE32PRE,szArchive,iMode);
	   CheckArchive_Print(ACE32DLL,r);
	//7Z
	r=CheckArchive_ChkArc(SVZIP32DLL,SVZIP32PRE,szArchive,iMode);
	   CheckArchive_Print(SVZIP32DLL,r);
	//IMP
	r=CheckArchive_ChkArc(UNIMP32DLL,UNIMP32PRE,szArchive,iMode);
	   CheckArchive_Print(UNIMP32DLL,r);
	//FTP
	r=CheckArchive_ChkArc(FTP32DLL,FTP32PRE,szArchive,iMode);
	   CheckArchive_Print(FTP32DLL,r);
	//ISH
	r=CheckArchive_ChkArc(ISH32DLL,ISH32PRE,szArchive,iMode);
	   CheckArchive_Print(ISH32DLL,r);
	r=CheckArchive_ChkArc(DMISH32DLL,ISH32PRE,szArchive,iMode);
	   CheckArchive_Print(DMISH32DLL,r);
	r=CheckArchive_ChkArc(DMISHDLL,DMISHPRE,szArchive,iMode);
	   CheckArchive_Print(DMISHDLL,r);
	r=CheckArchive_ChkArc(AISH32DLL,AISH32PRE,szArchive,iMode);
	   CheckArchive_Print(AISH32DLL,r);
	r=CheckArchive_ChkArc(AISHMV32DLL,AISHMV32PRE,szArchive,iMode);
	   CheckArchive_Print(AISHMV32DLL,r);
	//Unkanj
	r=CheckArchive_ChkArc(UNKANJDLL,CCPRE,szArchive,iMode);
	   CheckArchive_Print(UNKANJDLL,r);
	//JAK
	r=CheckArchive_ChkArc(JACK32DLL,JACK32PRE,szArchive,iMode);
	   CheckArchive_Print(JACK32DLL,r);
	//BH
	r=CheckArchive_ChkArc(BH32DLL,BH32PRE,szArchive,iMode);
	   CheckArchive_Print(BH32DLL,r);
	//NOA
	r=CheckArchive_ChkArc(NOA32WDLL,NOA32WPRE,szArchive,iMode);
	   CheckArchive_Print(NOA32WDLL,r);
	r=CheckArchive_ChkArc(NOA32DLL,NOA32PRE,szArchive,iMode);
	   CheckArchive_Print(NOA32DLL,r);
	//HKI
	r=CheckArchive_ChkArc(UNHKI32DLL,UNHKI32PRE,szArchive,iMode);
	   CheckArchive_Print(UNHKI32DLL,r);
	//DZIP
	r=CheckArchive_ChkArc(DZ32DLL,DZ32PRE,szArchive,iMode);
	   CheckArchive_Print(DZ32DLL,r);
	//HA
//	r=CheckArchive_ChkArc(HA32DLL,HA32PRE,szArchive,iMode);
//	   CheckArchive_Print(HA32DLL,r);
	//PMA
	r=CheckArchive_ChkArc(UNPMA32DLL,UNPMA32PRE,szArchive,iMode);
	   CheckArchive_Print(UNPMA32DLL,r);
	//ȏA]ڂꂽ`DLL

	//KTY
	r=CheckArchive_ChkArc(KTY32DLL,KTY32PRE,szArchive,iMode);
	   CheckArchive_Print(KTY32DLL,r);
	//ZZIP
	r=CheckArchive_ChkArc(ZZIP32DLL,ZZIP32PRE,szArchive,iMode);
	   CheckArchive_Print(ZZIP32DLL,r);
	//ALZ
	r=CheckArchive_ChkArc(UNALZ32DLL,UNALZ32PRE,szArchive,iMode);
	   CheckArchive_Print(UNALZ32DLL,r);
	//SQX
	r=CheckArchive_ChkArc(SQX32DLL,SQX32PRE,szArchive,iMode);
	   CheckArchive_Print(SQX32DLL,r);
	//ARC
	r=CheckArchive_ChkArc(UNARCDLL,UNARCPRE,szArchive,iMode);
	   CheckArchive_Print(UNARCDLL,r);
	//ZOO
	r=CheckArchive_ChkArc(UNZOODLL,UNZOOPRE,szArchive,iMode);
	   CheckArchive_Print(UNZOODLL,r);
	r=CheckArchive_ChkArc(UNZOO32DLL,UNZOO32PRE,szArchive,iMode);
	   CheckArchive_Print(UNZOO32DLL,r);
	//RK
	r=CheckArchive_ChkArc(RK32DLL,RK32PRE,szArchive,iMode);
	   CheckArchive_Print(RK32DLL,r);
	//IS
	r=CheckArchive_ChkArc(ARCEXTJDLL,ARCEXTJPRE,szArchive,iMode);
	   CheckArchive_Print(ARCEXTJDLL,r);
	//PAQAR
	r=CheckArchive_ChkArc(PAQAR32DLL,PAQAR32PRE,szArchive,iMode);
	   CheckArchive_Print(PAQAR32DLL,r);
//	r=CheckArchive_ChkArc(PAQ32DLL,PAQ32PRE,szArchive,iMode);
//	   CheckArchive_Print(PAQ32DLL,r);
	//OAR
	r=CheckArchive_ChkArc(OAR32DLL,OAR32PRE,szArchive,iMode);
	   CheckArchive_Print(OAR32DLL,r);

	//Pt@C
	//APK
	r=CheckArchive_ChkArc(APLIBDLL,APLIBPRE,szArchive,iMode);
	   CheckArchive_Print(APLIBDLL,r);
	//JC1
	r=CheckArchive_ChkArc(JCALG32DLL,JCALG32PRE,szArchive,iMode);
	   CheckArchive_Print(JCALG32DLL,r);
	//BLZ
	r=CheckArchive_ChkArc(BRIEFLZDLL,BRIEFLZPRE,szArchive,iMode);
	   CheckArchive_Print(BRIEFLZDLL,r);
	//UCL
	r=CheckArchive_ChkArc(UCL32DLL,UCL32PRE,szArchive,iMode);
	   CheckArchive_Print(UCL32DLL,r);
	//ZLP
	r=CheckArchive_ChkArc(ZLP32DLL,ZLP32PRE,szArchive,iMode);
	   CheckArchive_Print(ZLP32DLL,r);
	//SPL
	r=CheckArchive_ChkArc(SPL32DLL,SPL32PRE,szArchive,iMode);
	   CheckArchive_Print(SPL32DLL,r);
	//??_
	r=CheckArchive_ChkArc(LZ32JDLL,LZ32JPRE,szArchive,iMode);
	   CheckArchive_Print(LZ32JDLL,r);
	//B64
	r=CheckArchive_ChkArc(BASE64ARCDLL,BASE64ARCPRE,szArchive,iMode);
	   CheckArchive_Print(BASE64ARCDLL,r);
	//JAM
	r=CheckArchive_ChkArc(JAM32DLL,JAM32PRE,szArchive,iMode);
	   CheckArchive_Print(JAM32DLL,r);
	r=CheckArchive_ChkArc(UNJAM32DLL,UNJAM32PRE,szArchive,iMode);
	   CheckArchive_Print(UNJAM32DLL,r);

	//SPI
	r=CheckArchive_ChkArc(CASPI32DLL,CASPI32PRE,szArchive,iMode);
	   CheckArchive_Print(CASPI32DLL,r);
	r=CheckArchive_ChkArc(SPIDLL,SPIPRE,szArchive,iMode);
	   CheckArchive_Print(SPIDLL,r);
	//XACRETT
	r=CheckArchive_ChkArc(XACRETTDLL,XACRETTPRE,szArchive,iMode);
	   CheckArchive_Print(XACRETTDLL,r);
	//JPZ
	r=CheckArchive_ChkArc(JPZ32DLL,JPZ32PRE,szArchive,iMode);
	   CheckArchive_Print(JPZ32DLL,r);
	//SHELLCA
	r=CheckArchive_ChkArc(SHELLCADLL,SHELLCAPRE,szArchive,iMode);
	   CheckArchive_Print(SHELLCADLL,r);

	return 100;
}
