//
// FuncList.c
// QueryFunctionList
//

//ZipTV Routine of Bh32.dll:
/**********************************************************************

  Copyright 1998-2004,  Microchip Data Systems / Carl Bunton

  Any revision or distribution of sources or any compiled dll dealing
  with the BlakHole (.bh extension) compression format requires this
  copyright notice be included in the source, documentation, and help
  files.

  Alterations to the BlakHole compressed header format can not be
  made without prior express written consent by the author.

  Web-site:  http://www.ziptv.com
**********************************************************************/

#include "StdAfx.h"

bool QueryFunc_ChkFunc(LPCSTR szDll, LPCSTR szPrefix, const int iFunc, const int iMode){
	int result=2;
	char szFlist[26];
	HMODULE hDll = LoadLibrary(szDll);

	wsprintf(szFlist,"%s%s",szPrefix,FUNC);

	if (hDll){
		FARPROC fp = GetProcAddress(hDll,szFlist);
		if (fp)
			result = ((QueryFunctionList)fp)(iFunc) ? 0 : 1;
	}
	FreeLibrary(hDll);

	return iMode==1 ? result!=2 : result==0;
    /*
	Mode:
	1 -> FunctionListAvailable?
	2 -> FunctionIsAvailable?
    */
}

int QueryFunc(LPCSTR szFunc, const int iMode){
	int iFunc=0;

	ConsoleAqua();

	if (iMode==2){
		if(!szFunc){
			ConsoleRed();
			printf(ConsoleIsJP()?"@\w肳Ă܂":"Function NOT Specified.");
			return 101;
		}
		iFunc = atoi(szFunc);
		printf("%s() -> <%d>\n(All Library)\n\n",FUNC,iFunc);
	}

	if (iMode==1) printf(ConsoleIsJP()
						?"%s()͎DLLŎgpł܂:\n\n"
						:"%s() is Available on:\n\n",FUNC);
	ConsoleYellow();

	if (QueryFunc_ChkFunc(UNLHA32DLL,UNLHA32PRE,iFunc,iMode))
	printf("%s\n",UNLHA32DLL);
	if (QueryFunc_ChkFunc(IUNLHA32DLL,IUNLHA32PRE,iFunc,iMode))
	printf("%s\n",IUNLHA32DLL);
	if (QueryFunc_ChkFunc(UNZIP32DLL,UNZIP32PRE,iFunc,iMode))
	printf("%s\n",UNZIP32DLL);
	if (QueryFunc_ChkFunc(ZIP32JDLL,ZIP32JPRE,iFunc,iMode))
	printf("%s\n",ZIP32JDLL);
	if (QueryFunc_ChkFunc(LMZIP32DLL,LMZIP32PRE,iFunc,iMode))
	printf("%s\n",LMZIP32DLL);
	if (QueryFunc_ChkFunc(CAB32DLL,CAB32PRE,iFunc,iMode))
	printf("%s\n",CAB32DLL);
	if (QueryFunc_ChkFunc(UNARJ32JDLL,UNARJ32JPRE,iFunc,iMode))
	printf("%s\n",UNARJ32JDLL);
	if (QueryFunc_ChkFunc(TAR32DLL,TAR32PRE,iFunc,iMode))
	printf("%s\n",TAR32DLL);
	if (QueryFunc_ChkFunc(BGA32DLL,BGA32PRE,iFunc,iMode))
	printf("%s\n",BGA32DLL);
	if (QueryFunc_ChkFunc(UNBEL32DLL,UNBEL32PRE,iFunc,iMode))
	printf("%s\n",UNBEL32DLL);
	if (QueryFunc_ChkFunc(UNGCA32DLL,UNGCA32PRE,iFunc,iMode))
	printf("%s\n",UNGCA32DLL);
	if (QueryFunc_ChkFunc(YZ1DLL,YZ1PRE,iFunc,iMode))
	printf("%s\n",YZ1DLL);
	if (QueryFunc_ChkFunc(UNYZ1DLL,UNYZ1PRE,iFunc,iMode))
	printf("%s\n",UNYZ1DLL);
	if (QueryFunc_ChkFunc(YYZ32DLL,YZ1PRE,iFunc,iMode))
	printf("%s\n",YYZ32DLL);
	if (QueryFunc_ChkFunc(YYZDLL,YYZPRE,iFunc,iMode))
	printf("%s\n",YYZDLL);
	if (QueryFunc_ChkFunc(YZ2DLL,YZ2PRE,iFunc,iMode))
	printf("%s\n",YZ2DLL);
	if (QueryFunc_ChkFunc(UNRAR32DLL,UNRAR32PRE,iFunc,iMode))
	printf("%s\n",UNRAR32DLL);
	if (QueryFunc_ChkFunc(UNACE32DLL,UNACE32PRE,iFunc,iMode))
	printf("%s\n",UNACE32DLL);
	if (QueryFunc_ChkFunc(UNACEV2JDLL,UNACEV2JPRE,iFunc,iMode))
	printf("%s\n",UNACEV2JDLL);
	if (QueryFunc_ChkFunc(ACE32DLL,ACE32PRE,iFunc,iMode))
	printf("%s\n",ACE32DLL);
	if (QueryFunc_ChkFunc(SVZIP32DLL,SVZIP32PRE,iFunc,iMode))
	printf("%s\n",SVZIP32DLL);
	if (QueryFunc_ChkFunc(UNIMP32DLL,UNIMP32PRE,iFunc,iMode))
	printf("%s\n",UNIMP32DLL);
	if (QueryFunc_ChkFunc(FTP32DLL,FTP32PRE,iFunc,iMode))
	printf("%s\n",FTP32DLL);
	if (QueryFunc_ChkFunc(ISH32DLL,ISH32PRE,iFunc,iMode))
	printf("%s\n",ISH32DLL);
	if (QueryFunc_ChkFunc(DMISH32DLL,ISH32PRE,iFunc,iMode))
	printf("%s\n",DMISH32DLL);
	if (QueryFunc_ChkFunc(DMISHDLL,DMISHPRE,iFunc,iMode))
	printf("%s\n",DMISHDLL);
	if (QueryFunc_ChkFunc(AISH32DLL,AISH32PRE,iFunc,iMode))
	printf("%s\n",AISH32DLL);
	if (QueryFunc_ChkFunc(AISHMV32DLL,AISHMV32PRE,iFunc,iMode))
	printf("%s\n",AISHMV32DLL);
	if (QueryFunc_ChkFunc(UNKANJDLL,CCPRE,iFunc,iMode))
	printf("%s\n",UNKANJDLL);
	if (QueryFunc_ChkFunc(JACK32DLL,JACK32PRE,iFunc,iMode))
	printf("%s\n",JACK32DLL);
	if (QueryFunc_ChkFunc(BH32DLL,BH32PRE,iFunc,iMode))
	printf("%s\n",BH32DLL);
	if (QueryFunc_ChkFunc(NOA32WDLL,NOA32WPRE,iFunc,iMode))
	printf("%s\n",NOA32WDLL);
	if (QueryFunc_ChkFunc(NOA32DLL,NOA32PRE,iFunc,iMode))
	printf("%s\n",NOA32DLL);
	if (QueryFunc_ChkFunc(UNHKI32DLL,UNHKI32PRE,iFunc,iMode))
	printf("%s\n",UNHKI32DLL);
	if (QueryFunc_ChkFunc(DZ32DLL,DZ32PRE,iFunc,iMode))
	printf("%s\n",DZ32DLL);
//	if (QueryFunc_ChkFunc(HA32DLL,HA32PRE,iFunc,iMode))
//	printf("%s\n",HA32DLL);
	if (QueryFunc_ChkFunc(UNPMA32DLL,UNPMA32PRE,iFunc,iMode))
	printf("%s\n",UNPMA32DLL);

	if (QueryFunc_ChkFunc(KTY32DLL,KTY32PRE,iFunc,iMode))
	printf("%s\n",KTY32DLL);
	if (QueryFunc_ChkFunc(ZZIP32DLL,ZZIP32PRE,iFunc,iMode))
	printf("%s\n",ZZIP32DLL);
	if (QueryFunc_ChkFunc(UNALZ32DLL,UNALZ32PRE,iFunc,iMode))
	printf("%s\n",UNALZ32DLL);
	if (QueryFunc_ChkFunc(SQX32DLL,SQX32PRE,iFunc,iMode))
	printf("%s\n",SQX32DLL);
	if (QueryFunc_ChkFunc(UNARCDLL,UNARCPRE,iFunc,iMode))
	printf("%s\n",UNARCDLL);
	if (QueryFunc_ChkFunc(UNZOODLL,UNZOOPRE,iFunc,iMode))
	printf("%s\n",UNZOODLL);
	if (QueryFunc_ChkFunc(UNZOO32DLL,UNZOO32PRE,iFunc,iMode))
	printf("%s\n",UNZOO32DLL);
	if (QueryFunc_ChkFunc(RK32DLL,RK32PRE,iFunc,iMode))
	printf("%s\n",RK32DLL);
	if (QueryFunc_ChkFunc(ARCEXTJDLL,ARCEXTJPRE,iFunc,iMode))
	printf("%s\n",ARCEXTJDLL);
	if (QueryFunc_ChkFunc(PAQAR32DLL,PAQAR32PRE,iFunc,iMode))
	printf("%s\n",PAQAR32DLL);
//	if (QueryFunc_ChkFunc(PAQ32DLL,PAQ32PRE,iFunc,iMode))
//	printf("%s\n",PAQ32DLL);
	if (QueryFunc_ChkFunc(OAR32DLL,OAR32PRE,iFunc,iMode))
	printf("%s\n",OAR32DLL);

	if (QueryFunc_ChkFunc(APLIBDLL,APLIBPRE,iFunc,iMode))
	printf("%s\n",APLIBDLL);
	if (QueryFunc_ChkFunc(JCALG32DLL,JCALG32PRE,iFunc,iMode))
	printf("%s\n",JCALG32DLL);
	if (QueryFunc_ChkFunc(BRIEFLZDLL,BRIEFLZPRE,iFunc,iMode))
	printf("%s\n",BRIEFLZDLL);
	if (QueryFunc_ChkFunc(UCL32DLL,UCL32PRE,iFunc,iMode))
	printf("%s\n",UCL32DLL);
	if (QueryFunc_ChkFunc(ZLP32DLL,ZLP32PRE,iFunc,iMode))
	printf("%s\n",ZLP32DLL);
	if (QueryFunc_ChkFunc(SPL32DLL,SPL32PRE,iFunc,iMode))
	printf("%s\n",SPL32DLL);
	if (QueryFunc_ChkFunc(LZ32JDLL,LZ32JPRE,iFunc,iMode))
	printf("%s\n",LZ32JDLL);
	if (QueryFunc_ChkFunc(BASE64ARCDLL,BASE64ARCPRE,iFunc,iMode))
	printf("%s\n",BASE64ARCDLL);
	if (QueryFunc_ChkFunc(JAM32DLL,JAM32PRE,iFunc,iMode))
	printf("%s\n",JAM32DLL);
	if (QueryFunc_ChkFunc(UNJAM32DLL,UNJAM32PRE,iFunc,iMode))
	printf("%s\n",UNJAM32DLL);
	if (QueryFunc_ChkFunc(JPZ32DLL,JPZ32PRE,iFunc,iMode))
	printf("%s\n",JPZ32DLL);
	if (QueryFunc_ChkFunc(SHELLCADLL,SHELLCAPRE,iFunc,iMode))
	printf("%s\n",SHELLCADLL);

	if (QueryFunc_ChkFunc(CRYPTZIPDLL,CRYPTZIPPRE,iFunc,iMode))
	printf("%s\n",CRYPTZIPDLL);
	if (QueryFunc_ChkFunc(NKFDLL,NKFPRE,iFunc,iMode))
	printf("%s\n",NKFDLL);
	if (QueryFunc_ChkFunc(REDUCEPEDLL,REDUCEPEPRE,iFunc,iMode))
	printf("%s\n",REDUCEPEDLL);
	if (QueryFunc_ChkFunc(WINEXDLL,WINEXPRE,iFunc,iMode))
	printf("%s\n",WINEXDLL);
	if (QueryFunc_ChkFunc(HALDELPHICADLL,HALDELPHICAPRE,iFunc,iMode))
	printf("%s\n",HALDELPHICADLL);

	if (QueryFunc_ChkFunc(CASPI32DLL,CASPI32PRE,iFunc,iMode))
	printf("%s\n",CASPI32DLL);
	if (QueryFunc_ChkFunc(SPIDLL,SPIPRE,iFunc,iMode))
	printf("%s\n",SPIDLL);
	if (QueryFunc_ChkFunc(XACRETTDLL,XACRETTPRE,iFunc,iMode))
	printf("%s\n",XACRETTDLL);
	return 100;
}
