//
// GetVer.c
// Version Info.
//

//ZipTV Routine of Bh32.dll:
/**********************************************************************

  Copyright 1998-2004,  Microchip Data Systems / Carl Bunton

  Any revision or distribution of sources or any compiled dll dealing
  with the BlakHole (.bh extension) compression format requires this
  copyright notice be included in the source, documentation, and help
  files.

  Alterations to the BlakHole compressed header format can not be
  made without prior express written consent by the author.

  Web-site:  http://www.ziptv.com
**********************************************************************/

#include "StdAfx.h"

int GetVersion_Getver(LPCSTR szDll, LPCSTR szPrefix, LPSTR szBuffer){
	int result=2;
	char gv[30];
	char gsv[30];
	WORD v1,v2;

	FARPROC fp;

	HMODULE hDll = LoadLibrary(szDll);
	if (hDll){
		wsprintf(gv ,"%s%s",szPrefix,UNYZ1GV);
		if (fp = GetProcAddress(hDll,gv)){
			v1 = ((Getversion)fp)();
			wsprintf(gsv,"%s%s",szPrefix,UNYZ1GSV);
			if (fp = GetProcAddress(hDll,gsv)){
				v2 = ((Getversion)fp)();
				wsprintf(szBuffer,"%d.%02d.%d.%02d",v1/100,v1%100,v2/100,v2%100);
			}else{
				wsprintf(szBuffer,"%d.%02d     ",v1/100,v1%100);
			}
			result=0;
		}

		wsprintf(gv ,"%s%s",szPrefix,GV);
		if (result==2&&(fp = GetProcAddress(hDll,gv))){
			v1 = ((Getversion)fp)();
			wsprintf(gsv,"%s%s",szPrefix,GSV);
			if (fp = GetProcAddress(hDll,gsv)){
				v2 = ((Getversion)fp)();
				wsprintf(szBuffer,"%d.%02d.%d.%02d",v1/100,v1%100,v2/100,v2%100);
			}else{
				wsprintf(szBuffer,"%d.%02d     ",v1/100,v1%100);
			}
			result=0;
		}

		if (result==2&&(fp = GetProcAddress(hDll,szPrefix))){
			v1 = ((Getversion)fp)();
			wsprintf(szBuffer,"%d.%02d     ",v1/100,v1%100);
			result=0;
		}

		if(result==2){
			lstrcpy(szBuffer,"OK!      ");
			result=1;
		}

	}else{
		lstrcpy(szBuffer,"---------");
	}
	FreeLibrary(hDll);
	return result;
}

void GetVersion_Printver(LPCSTR szDll,LPCSTR szCopyright,LPCSTR szVersion,const int iMode){
	char szDllstr[17];
	wsprintf(szDllstr,"%-12s ",szDll);
	printf(szDllstr);
	switch(iMode){
		case 2:  ConsolePurple(); break;
		case 1:  ConsoleGreen();  break;
		default: ConsoleYellow(); break;
	}
	printf(szVersion);
	ConsoleAqua();
	printf(" (C) %s\n",szCopyright);
}

void GetVersion_Pversion(LPCSTR szDll,LPCSTR szCopyright){
	char szDllstr[25];
	wsprintf(szDllstr,"%-12s ",szDll);
	printf(szDllstr);
	GetVerString((char*)szDll);
	ConsoleAqua();
	printf(" (C) %s\n",szCopyright);
}

int GetVersion_Get(DWORD dwOption){
	//ANZXCɕ\I
	//_~[֐͋CɂȂI
	int i;
	char buf[10];

	ConsoleGreen();
	printf("Version Info.\n\nCLA Version: 3.99 Beta%d\n",CLAVersion);
	if (dwOption&GV_4) {Version_OSVer(); Version_IEVer();};
	ConsoleBlue();
	printf("%s\n",VerLn);
	ConsoleAqua();
	i=GetVersion_Getver(UNLHA32DLL,UNLHA32PRE,buf);
	GetVersion_Printver(UNLHA32DLL,"Micco",buf,i);

	//DMZip32.dll?
	switch(CollectUnZip()){
		case 0:
			i=GetVersion_Getver(UNZIP32DLL,UNZIP32PRE,buf);
			GetVersion_Printver(UNZIP32DLL,"shoda.T",buf,i);
			break;
		case 1:
			i=GetVersion_Getver(UNZIP32DLL,MICUZVER,buf);
			GetVersion_Printver(UNZIP32DLL,"Micco (DMZip32.dll)",buf,i);
			break;
		case 2:
			i=GetVersion_Getver(UNZIP32DLL,UNZIP32PRE,buf);
			GetVersion_Printver(UNZIP32DLL,"Heropa (funzip32.dll)",buf,i);
			break;
		default:
			GetVersion_Printver(UNZIP32DLL,"shoda.T","---------",2);
			break;
	}

	i=GetVersion_Getver(ZIP32JDLL,ZIP32JPRE,buf);
	GetVersion_Printver(ZIP32JDLL,"Tsuneo Yoshioka",buf,i);
	i=GetVersion_Getver(LMZIP32DLL,LMZIP32PRE,buf);
	GetVersion_Printver(LMZIP32DLL,"Naoki Yanagi",buf,i);

	//DCab32.dll?
	i=GetVersion_Getver(CAB32DLL,CAB32PRE,buf);
	GetVersion_Printver(CAB32DLL,"Kuniaki Miyauchi",buf,i);
	if (CollectCab()==1)
	GetVersion_Printver(CAB32DLL,"mij4x (DCab32.dll)",buf,i);

	i=GetVersion_Getver(UNARJ32JDLL,UNARJ32JPRE,buf);
	GetVersion_Printver(UNARJ32JDLL,"Micco",buf,i);
	i=GetVersion_Getver(TAR32DLL,TAR32PRE,buf);
	GetVersion_Printver(TAR32DLL,"Tsuneo Yoshioka",buf,i);

	//QBga32.dll?
	i=GetVersion_Getver(BGA32DLL,BGA32PRE,buf);
	GetVersion_Printver(BGA32DLL,"Toshinobu Kimura",buf,i);
	if (CollectBga()==1){
		i=GetVersion_Getver(BGA32DLL,QBGAVER,buf);
		GetVersion_Printver(BGA32DLL,"K.INABA (QBga32.dll)",buf,i);
	}

	i=GetVersion_Getver(UNBEL32DLL,UNBEL32PRE,buf);
	GetVersion_Printver(UNBEL32DLL,"Shimada Misha Hirofumi",buf,i);
	i=GetVersion_Getver(UNGCA32DLL,UNGCA32PRE,buf);
	GetVersion_Printver(UNGCA32DLL,"Akiharu Amano",buf,i);
	i=GetVersion_Getver(YZ1DLL,YZ1PRE,buf);
	GetVersion_Printver(YZ1DLL,"K.INABA",buf,i);
	i=GetVersion_Getver(UNYZ1DLL,UNYZ1PRE,buf);
	GetVersion_Printver(UNYZ1DLL,"Shimada Misha Hirofumi",buf,i);
	i=GetVersion_Getver(UNRAR32DLL,UNRAR32PRE,buf);
	GetVersion_Printver(UNRAR32DLL,"Tetsuya Kamei",buf,i);
	i=GetVersion_Getver(SVZIP32DLL,SVZIP32PRE,buf);
	GetVersion_Printver(SVZIP32DLL,"Minoru Akita",buf,i);
	i=GetVersion_Getver(UNIMP32DLL,UNIMP32PRE,buf);
	GetVersion_Printver(UNIMP32DLL,"HyperBeat Software",buf,i);
	i=GetVersion_Getver(FTP32DLL,FTP32PRE,buf);
	GetVersion_Printver(FTP32DLL,"Tsuneo Yoshioka",buf,i);
	i=GetVersion_Getver(ISH32DLL,ISH32PRE,buf);
	GetVersion_Printver(ISH32DLL,"nonki",buf,i);
	i=GetVersion_Getver(AISH32DLL,AISH32PRE,buf);
	GetVersion_Printver(AISH32DLL,"Hiroyuki Shimada",buf,i);
	i=GetVersion_Getver(AISHMV32DLL,AISHMV32PRE,buf);
	GetVersion_Printver(AISHMV32DLL,"Hiroyuki Shimada",buf,i);
	i=GetVersion_Getver(UNKANJDLL,CCPRE,buf);
	GetVersion_Printver(UNKANJDLL,"og",buf,i);
	i=GetVersion_Getver(JACK32DLL,JACK32PRE,buf);
	GetVersion_Printver(JACK32DLL,"Toshinobu Kimura",buf,i);
	i=GetVersion_Getver(BH32DLL,BH32PRE,buf);
	GetVersion_Printver(BH32DLL,"HAL M. Pussywillow",buf,i);
	i=GetVersion_Getver(YZ2DLL,YZ2PRE,buf);
	GetVersion_Printver(YZ2DLL,"HAL M. Pussywillow",buf,i);
	i=GetVersion_Getver(UNACEV2JDLL,UNACEV2JPRE,buf);
	GetVersion_Printver(UNACEV2JDLL,"Heropa",buf,i);
	i=GetVersion_Getver(NOA32WDLL,NOA32WPRE,buf);
	GetVersion_Printver(NOA32WDLL,"HAL M. Pussywillow",buf,i);
	i=GetVersion_Getver(NOA32DLL,NOA32PRE,buf);
	GetVersion_Printver(NOA32DLL,"HAL M. Pussywillow",buf,i);
	i=GetVersion_Getver(UNHKI32DLL,UNHKI32PRE,buf);
	GetVersion_Printver(UNHKI32DLL,"Silky",buf,i);
	i=GetVersion_Getver(DZ32DLL,DZ32PRE,buf);
	GetVersion_Printver(DZ32DLL,"HAL M. Pussywillow",buf,i);
	GetVersion_Pversion(HA32DLL,"HAL M. Pussywillow");
	i=GetVersion_Getver(UNPMA32DLL,UNPMA32PRE,buf);
	GetVersion_Printver(UNPMA32DLL,"HAL M. Pussywillow",buf,i);

	if (dwOption&GV_1){
		printf("\n");
		i=GetVersion_Getver(KTY32DLL,KTY32PRE,buf);
		GetVersion_Printver(KTY32DLL,"HyperBeat Software",buf,i);
		i=GetVersion_Getver(ZZIP32DLL,ZZIP32PRE,buf);
		GetVersion_Printver(ZZIP32DLL,"HyperBeat Software",buf,i);
		i=GetVersion_Getver(UNALZ32DLL,UNALZ32PRE,buf);
		GetVersion_Printver(UNALZ32DLL,"HyperBeat Software",buf,i);
		i=GetVersion_Getver(UNACE32DLL,UNACE32PRE,buf);
		GetVersion_Printver(UNACE32DLL,"Shimada Misha Hirofumi",buf,i);
		i=GetVersion_Getver(ACE32DLL,ACE32PRE,buf);
		GetVersion_Printver(ACE32DLL,"HAL M. Pussywillow",buf,i);
		i=GetVersion_Getver(IUNLHA32DLL,IUNLHA32PRE,buf);
		GetVersion_Printver(IUNLHA32DLL,"miyax(mij4x)",buf,i);
		i=GetVersion_Getver(SQX32DLL,SQX32PRE,buf);
		GetVersion_Printver(SQX32DLL,"mij4x",buf,i);
		GetVersion_Pversion(YYZ32DLL,"Shoji Yoneda");
		i=GetVersion_Getver(YYZDLL,YYZPRE,buf);
		GetVersion_Printver(YYZDLL,"HAL M. Pussywillow",buf,i);
		i=GetVersion_Getver(KB7ZDLL,SVZIP32PRE,buf);
		GetVersion_Printver(KB7ZDLL,"Kobarin",buf,i);
		i=GetVersion_Getver(DMISH32DLL,ISH32PRE,buf);
		GetVersion_Printver(DMISH32DLL,"S.Noda",buf,i);
		i=GetVersion_Getver(DMISHDLL,DMISHPRE,buf);
		GetVersion_Printver(DMISHDLL,"HAL M. Pussywillow",buf,i);
		i=GetVersion_Getver(UNARCDLL,UNARCPRE,buf);
		GetVersion_Printver(UNARCDLL,"HAL M. Pussywillow",buf,i);
		i=GetVersion_Getver(UNZOODLL,UNZOOPRE,buf);
		GetVersion_Printver(UNZOODLL,"HAL M. Pussywillow",buf,i);
		i=GetVersion_Getver(UNZOO32DLL,UNZOO32PRE,buf);
		GetVersion_Printver(UNZOO32DLL,"Mizuty",buf,i);
		i=GetVersion_Getver(RK32DLL,RK32PRE,buf);
		GetVersion_Printver(RK32DLL,"Heropa",buf,i);
		i=GetVersion_Getver(ARCEXTJDLL,ARCEXTJPRE,buf);
		GetVersion_Printver(ARCEXTJDLL,"HAL M. Pussywillow",buf,i);
		i=GetVersion_Getver(PAQAR32DLL,PAQAR32PRE,buf);
		GetVersion_Printver(PAQAR32DLL,"Silky",buf,i);
		GetVersion_Pversion(PAQ32DLL,"Silky");
		i=GetVersion_Getver(OAR32DLL,OAR32PRE,buf);
		GetVersion_Printver(OAR32DLL,"hira",buf,i);
		i=GetVersion_Getver(BASE64ARCDLL,BASE64ARCPRE,buf);
		GetVersion_Printver(BASE64ARCDLL,"hira",buf,i);
		i=GetVersion_Getver(APLIBDLL,APLIBPRE,buf);
		GetVersion_Printver(APLIBDLL,"HAL M. Pussywillow",buf,i);
		i=GetVersion_Getver(JCALG32DLL,JCALG32PRE,buf);
		GetVersion_Printver(JCALG32DLL,"HAL M. Pussywillow",buf,i);
		i=GetVersion_Getver(BRIEFLZDLL,BRIEFLZPRE,buf);
		GetVersion_Printver(BRIEFLZDLL,"HAL M. Pussywillow",buf,i);
		i=GetVersion_Getver(UCL32DLL,UCL32PRE,buf);
		GetVersion_Printver(UCL32DLL,"HAL M. Pussywillow",buf,i);
		i=GetVersion_Getver(ZLP32DLL,ZLP32PRE,buf);
		GetVersion_Printver(ZLP32DLL,"HAL M. Pussywillow",buf,i);
		i=GetVersion_Getver(SPL32DLL,SPL32PRE,buf);
		GetVersion_Printver(SPL32DLL,"HAL M. Pussywillow",buf,i);
		i=GetVersion_Getver(LZ32JDLL,LZ32JPRE,buf);
		GetVersion_Printver(LZ32JDLL,"HAL M. Pussywillow",buf,i);
		i=GetVersion_Getver(JAM32DLL,JAM32PRE,buf);
		GetVersion_Printver(JAM32DLL,"Shimada Misha Hirofumi",buf,i);
		i=GetVersion_Getver(UNJAM32DLL,UNJAM32PRE,buf);
		GetVersion_Printver(UNJAM32DLL,"Shimada Misha Hirofumi",buf,i);
		i=GetVersion_Getver(JPZ32DLL,JPZ32PRE,buf);
		GetVersion_Printver(JPZ32DLL,"HAL M. Pussywillow",buf,i);
		i=GetVersion_Getver(SHELLCADLL,SHELLCAPRE,buf);
		GetVersion_Printver(SHELLCADLL,"HAL M. Pussywillow",buf,i);
		i=GetVersion_Getver(CRYPTZIPDLL,CRYPTZIPPRE,buf);
		GetVersion_Printver(CRYPTZIPDLL,"HAL M. Pussywillow",buf,i);
		i=GetVersion_Getver(NKFDLL,NKFPRE,buf);
		GetVersion_Printver(NKFDLL,"HAL M. Pussywillow",buf,i);
		i=GetVersion_Getver(REDUCEPEDLL,REDUCEPEPRE,buf);
		GetVersion_Printver(REDUCEPEDLL,"HAL M. Pussywillow",buf,i);
		i=GetVersion_Getver(WINEXDLL,WINEXPRE,buf);
		GetVersion_Printver(WINEXDLL,"HAL M. Pussywillow",buf,i);
		i=GetVersion_Getver(HALDELPHICADLL,HALDELPHICAPRE,buf);
		GetVersion_Printver(HALDELPHICADLL,"HAL M. Pussywillow",buf,i);
		i=GetVersion_Getver(CASPI32DLL,CASPI32PRE,buf);
		GetVersion_Printver(CASPI32DLL,"miyax(mij4x)",buf,i);
		i=GetVersion_Getver(SPIDLL,SPIPRE,buf);
		GetVersion_Printver(SPIDLL,"Bonty",buf,i);
		i=GetVersion_Getver(XACRETTDLL,XACRETTPRE,buf);
		GetVersion_Printver(XACRETTDLL,"Bonty",buf,i);
		if (dwOption&GV_2){
			printf("\n");
			i=GetVersion_Getver(UNRARDLL,"RARGetDllVersion",buf);
			GetVersion_Printver(UNRARDLL,"Eugene Roshal",buf,i);
			i=GetVersion_Getver(IZIP32JDLL,"IZip32JGetVersion",buf);
			GetVersion_Printver(IZIP32JDLL,"Tsuneo Yoshioka",buf,i);
			i=GetVersion_Getver(ZCRYPT32DLL,"ZCrypt32GetVersion",buf);
			GetVersion_Printver(ZCRYPT32DLL,"Tsuneo Yoshioka",buf,i);
			i=GetVersion_Getver(BZ2LIBDLL,"BZ2GetVersion",buf);
			GetVersion_Printver(BZ2LIBDLL,"Tsuneo Yoshioka",buf,i);
			i=GetVersion_Getver(WINEX32DLL,WINEXPRE,buf);
			GetVersion_Printver(WINEX32DLL,"RedHouse",buf,i);
			i=GetVersion_Getver(NKF32DLL,CCPRE,buf);
			GetVersion_Printver(NKF32DLL,"Uminchu",buf,i);
			i=GetVersion_Getver(NOADLL,NOA32PRE,buf);
			GetVersion_Printver(NOADLL,"NAO",buf,i);
			i=GetVersion_Getver(ZIPDLL,"GetZipDllVersion",buf);
			GetVersion_Printver(ZIPDLL,"Eric W. Engler",buf,i);
			i=GetVersion_Getver(UNZDLL,"GetUnzDllVersion",buf);
			GetVersion_Printver(UNZDLL,"Eric W. Engler",buf,i);
			i=GetVersion_Getver(ZLIBDLL,"zlibVersion",buf);
			GetVersion_Printver(ZLIBDLL,"Mark Adler",buf,i);
			i=GetVersion_Getver(JRE32DLL,"JreGetVersion",buf);
			GetVersion_Printver(JRE32DLL,"Kazuo Yamada",buf,i);
			GetVersion_Pversion(ARC32DLL,"Toshinobu Kimura");
			GetVersion_Pversion(ZIP32DLL,"Info-ZIP");
			GetVersion_Pversion(ACEV2DLL,"Marcel Lemke");
			GetVersion_Pversion(UNACEV2DLL,"Marcel Lemke");
			i=GetVersion_Getver(UNACEDLL,CCPRE,buf);
			GetVersion_Printver(UNACEDLL,"Marcel Lemke",buf,i);
			GetVersion_Pversion(CABINETDLL,"Microsoft Corp.");
			GetVersion_Pversion(SQXDLL,"Sven Ritter");
			i=GetVersion_Getver(ZZLIBDLL,CCPRE,buf);
			GetVersion_Printver(ZZLIBDLL,"Damien Debin",buf,i);
			Version_StuffitVersion();
			if (dwOption&GV_3){
				printf("\n");
				i=GetVersion_Getver(GOGODLL,CCPRE,buf);
				GetVersion_Printver(GOGODLL,"Shigeo Mitsunari",buf,i);
				i=GetVersion_Getver(RCPCVDLL,CCPRE,buf);
				GetVersion_Printver(RCPCVDLL,"Fumy",buf,i);
				GetVersion_Pversion(VVWEBOCX,"Vivo Software");
				GetVersion_Pversion(CHROMADLL,"AiTHER");
				GetVersion_Pversion(LONGINUSDLL,"fuli mayer");
				GetVersion_Pversion(MSIEXECEXE,"Microsoft Corp.");
			}
		}
	}

	ConsoleBlue();
	printf(VerLn);

return 100;
}
